#!/usr/local/bin/perl -w 

package PDPASSWD;
use Crypt::Passwd::XS;

use strict;

#####
#####   PD-Admin crypt password routines
#####   (c) 2001 by Daniel Bradler
#####

sub make_password($) {
   my $password = shift;
   my $salt     = join '', ('.', '/', 0..9, 'A'..'Z', 'a'..'z')[rand 64, rand 64, rand 64, rand 64, rand 64, rand 64,
                                                                rand 64, rand 64, rand 64, rand 64, rand 64, rand 64];
   my $crypted_password = Crypt::Passwd::XS::crypt($password, '$1$'. $salt);
   return $crypted_password;
}

sub check_password($$) {
  my $plain_password   = shift;
  my $crypted_password = shift;
  return 0 unless (defined $plain_password and length $plain_password);
  if (Crypt::Passwd::XS::crypt($plain_password, $crypted_password) eq $crypted_password) {
    return 1
  } else {
    return 0
  }
}  

1;
