#!/bin/bash

LANG=en
PATH=/sbin:/bin:/usr/sbin:/usr/bin

if [ "$1" == "" ]; then
  echo "usage: $0 <ip>"
  exit
fi

DEVICE=eth0
bonding=`ifconfig | grep -c bond0`
if [ $bonding -ge 1 ]; then
   DEVICE=bond0
fi

run=1
while test $run -eq 1; do
  let counter=counter+1;
  ifconfig $DEVICE:$counter | grep "inet addr" >/dev/null || run=0
done
echo $counter

ifconfig $DEVICE:$counter $1 broadcast $1 netmask 255.255.255.255 up

test -e /etc/SuSE-release && {

cat <<__ >> /etc/sysconfig/network/ifcfg-$DEVICE
IPADDR_$counter='$1'
NETMASK_$counter='255.255.255.255'
LABEL_$counter='$counter'
__

}

test -e /etc/redhat-release && {
cat >> /etc/sysconfig/network-scripts/ifcfg-$DEVICE:$counter <<__
# Networking Interface
DEVICE=$DEVICE:$counter
BOOTPROTO=static
IPADDR=$1
NETMASK=255.255.255.255
__

}
