#!/bin/bash

###  pd-admin -- backup_mysql.sh
###
###  (c) 2004 by Daniel Bradler
###
###  $Id$

PASSWD=`cat /opt/pdadmin/etc/mysql_rootpw.conf 2>/dev/null`

if [ "$PASSWD" == "" ]; then
   echo "MySQL root password not configured."
   echo "Please edit /opt/pdadmin/etc/mysql_rootpw.conf";
   exit
fi

USER=$1
HOME=$2
DATABASE=$3

if [ "$USER" == "" -o "$HOME" == "" -o "$DATABASE" == "" ]; then
   echo "usage: $0 <user> <home> <database>"
   exit
fi

if [ ! -d $HOME/mysqldumps ]; then
  mkdir $HOME/mysqldumps || {
     echo "Couldn't create directory $HOME/mysqldumps"
     exit 1
  }
fi

chown $USER:$USER $HOME/mysqldumps
export PASSWD
export DATABASE
nice -n 19 setuidgid $USER /opt/pdadmin/bin/backup_write_dump.sh
