#!/bin/bash

###
###  pd-admin -- backup_user.sh
###
###  (c) 2004 by Daniel Bradler
###
###  $Id$
###

function mytar
{
   local tarfile=$1
   shift
   local srcdir=$1
   shift

   nice -n 19 tar -czf "$BACKUPDIR/system/$ROTATION/$tarfile" -C / "$srcdir"
}


PASSWD=`cat /opt/pdadmin/etc/mysql_rootpw.conf 2>/dev/null`

if [ "$PASSWD" == "" ]; then
   echo "MySQL root password not configured."
   echo "Please edit /opt/pdadmin/etc/mysql_rootpw.conf";
   exit
fi

BACKUPDIR=$1
ROTATION=$2

if [ "$BACKUPDIR" == "" -o "$ROTATION" == "" ]; then
   echo "usage: $0 <user> <home> <backupdir> <rotation>"
   exit
fi

if [ -d $BACKUPDIR/system/$ROTATION ]; then
   rm -Rf $BACKUPDIR/system/$ROTATION/* 2>/dev/null
else
   mkdir -p $BACKUPDIR/system/$ROTATION || {
      echo "Couldn't create $BACKUPDIR/system/$ROTATION"
      exit
   }
fi

chmod 700 $BACKUPDIR/system
chmod 700 $BACKUPDIR/system/$ROTATION
chown pdbackup:root $BACKUPDIR/system
echo $ROTATION >| $BACKUPDIR/system/.current
nice -n 19 mysqldump --add-drop-table -u root -p$PASSWD vadmin > $BACKUPDIR/system/$ROTATION/vadmin.dump
nice -n 19 mysqldump -u root -p$PASSWD mysql  > $BACKUPDIR/system/$ROTATION/mysql.dump

mytar opt_pdadmin_etc.tar.gz      opt/pdadmin/etc
mytar opt_pdadmin_sslcerts.tar.gz opt/pdadmin/sslcerts
mytar home_popuser.tar.gz         home/popuser 
mytar etc.tar.gz                  etc
mytar var_qmail_control.tar.gz    var/qmail/control
mytar var_qmail_users.tar.gz      var/qmail/users

shift
shift # $3 is now $1

for f in "$@"; do
   cp -a "$f" $BACKUPDIR/system/$ROTATION/
done
chown -R pdbackup:root $BACKUPDIR/system/$ROTATION
