#!/bin/bash

###  pd-admin -- user_backup.sh
###
###  (c) 2004 by Daniel Bradler
###
###  $Id$

USER=$1
HOME=$2
BACKUPDIR=$3
ROTATION=$4
EXCLUDE=$5

for i in $EXCLUDE; do
   PARM_EXCLUDE="$PARM_EXCLUDE --exclude=$i"
done

if [ "$USER" == "" -o "$HOME" == "" -o "$BACKUPDIR" == "" -o "$ROTATION" == "" ]; then
   echo "usage: $0 <user> <home> <backupdir> <rotation>"
   exit
fi

home2=$(readlink -e "$HOME") # canonize pathname (only single slashes)
relative_home=${home2#/}     # remove leading slash
[[ $relative_home = "" ]] && echo "FAIL: relative_home is empty" && exit 3

echo "Backup: $USER"
echo "================"

if [ -d $BACKUPDIR/user/$USER/$ROTATION ]; then
   rm -Rf $BACKUPDIR/user/$USER/$ROTATION/* 2>/dev/null
else
   mkdir -p $BACKUPDIR/user/$USER/$ROTATION || {
      echo "Couldn't create $BACKUPDIR/user/$USER/$ROTATION"
      exit
   }
fi

chmod 751 $BACKUPDIR/user
chown pdbackup:root $BACKUPDIR/user
chmod 750 $BACKUPDIR/user/$USER/$ROTATION
echo $ROTATION > $BACKUPDIR/user/$USER/.current
chown $USER $BACKUPDIR/user/$USER/$ROTATION
nice -n 19 setuidgid $USER tar --preserve-permissions $PARM_EXCLUDE \
   -czf $BACKUPDIR/user/$USER/$ROTATION/backup.tar.gz -C / $relative_home
chown -R pdbackup:$USER $BACKUPDIR/user/$USER/$ROTATION
touch $BACKUPDIR/user/$USER/$ROTATION
