#!/usr/local/pd-admin2/bin/perl -w

#####
#####  pd-admin - clear_quarantine_mailboxes.pl
#####
#####  (c) 1999 - 2006 by Daniel Bradler
#####

use strict;
use DBI;

#####
#####  Read Configuration
#####

use vars qw($popuser_name $dsn $user $password $quota_dev
            $quota_maxfiles $quota_blocks_per_kb $quota_diff_hardlimit);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't read configuration: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

#####
#####  Main
#####

my $query = "select t1.home from pop3 as t1, users as t2 where t2.quarantinebox=t1.id and t2.spamfilter='on'";
my $sth   = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv    = $sth->execute or die "cannot execute query '$query'";

while (my ($home)  = $sth->fetchrow_array) {
   system '/opt/pdadmin/bin/rm_old_mail.sh',  "$home/Maildir";
}
$sth->finish;
$dbh->disconnect;
