#!/bin/bash
#
#  control-clamd.sh
#  2023-11-20 stvo
#
source /usr/local/pd-admin2/SETENV
set -Ceu
if [ "$BASH_VERSINFO" -ne "2" ]; then
   set -o pipefail
fi
#set -x

active=/service
susp=/service.suspended
mkdir -p $susp

function regenerate_simcontrol_cdb_files
{
   /usr/local/pd-admin2/qmail/bin/simscanmk
   CONTROLDIR=/var/qmail/simcontrol-msa /usr/local/pd-admin2/qmail/bin/simscanmk
}

function deactivate_clam_in_simcontrol_files
{
   sed -i 's/clam=yes/clam=no/g' /var/qmail/simcontrol/simcontrol
   sed -i 's/clam=yes/clam=no/g' /var/qmail/simcontrol-msa/simcontrol
}

function activate_clam_in_simcontrol_files
{
   sed -i 's/clam=no/clam=yes/g' /var/qmail/simcontrol/simcontrol
   sed -i 's/clam=no/clam=yes/g' /var/qmail/simcontrol-msa/simcontrol
}

function disable_service
{
   mv $active/clamd $susp/
   (
      sleep 1
      svc -dx $susp/clamd
   )&
   echo "clamd disabled"
}

function enable_service
{
   mv $susp/clamd $active/
   echo "clamd enabled"
}

action=${1:-}
echo "action = <$action>"
case $action in
   disable)
      deactivate_clam_in_simcontrol_files
      regenerate_simcontrol_cdb_files
      disable_service
      ;;
   enable)
      activate_clam_in_simcontrol_files
      regenerate_simcontrol_cdb_files
      enable_service
      ;;
   *)
      echo "usage: $0 (enable | disable)"
      exit 1
      ;;
esac
