#!/bin/bash
#
#  delete-customer.sh
#  2023-06-07 stvo
#  BNK/PDA#115
#
set -CEeuo pipefail
source /usr/local/pd-admin2/SETENV
#set -x

trap "echo \"\$errmsg\" >&2" ERR

errmsg="must run as root"
test $EUID = 0

errmsg="usage: $0 <reseller login> <customer login>"
test $# = 2

reseller=$1
login=$2

errmsg='reseller contains illegal characters or is not at least 1 character long'
[[ $reseller =~ ^[[:alnum:]]+$ ]]

errmsg='customer contains illegal characters or is not eight characters long'
[[ $login =~ ^[[:alnum:]]{8}$ ]]

errmsg="could not read MySQL root password"
MYSQL_PWD=$(cat /opt/pdadmin/etc/mysql_rootpw.conf)
export MYSQL_PWD

function domains_by_user_login ()
{
   local login=$1
   local LANG
   mysql vadmin -NB <<_
      select domains.name
      from domains left join users
      on domains.owner = users.id
      where users.login = '$login'
_
}

errmsg='could not query MySQL Database vadmin'
domains=($(domains_by_user_login $login))

errmsg="no domains found for customer <$login>"
echo "number of domains found: ${#domains[@]}"
[[ ${#domains[@]} > 0 ]]

trap "" ERR
for dom in "${domains[@]}"; do
   echo
   echo "==== $dom ===="
   echo
   /opt/pdadmin/bin/domain_del.pl "$dom" --reseller "$reseller"
done

echo fin
