#!/usr/local/pd-admin2/bin/perl -w

use strict;
use Fcntl ':flock';

####
####  read configuration
####

use vars qw($domrobot_queue_time);
do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't read configuration: $!";

####
####  main
####

$domrobot_queue_time ||= 1800;

open LOCK, ">>/opt/pdadmin/tmp/.domreg-queue-lock" or
   die "/opt/pdadmin/tmp/.domreg-queue-lock: $!\n";
flock LOCK, LOCK_EX;

unless (-d '/opt/pdadmin/queue/done') {
  mkdir '/opt/pdadmin/queue/done', 0700 
        or die "cannot mkdir /opt/pdadmin/queue/done: $!\n";
}

for my $file (</opt/pdadmin/queue/todo/*>) {
    my ($time) = $file =~ m:.*/(\d+)-:;
    if (time - $time >= $domrobot_queue_time) {
       # raus damit
       open FILE, $file or die "$file: $!";
       flock FILE, LOCK_EX;
       my $mail = join '', <FILE>;
       open MAIL, "|/var/qmail/bin/qmail-inject" 
            or die "cannot fork for qmail-inject: $!\n";
       print MAIL $mail;
       close MAIL or die "cannot close qmail-inject nicely: $!\n";
       system "mv $file /opt/pdadmin/queue/done" and
            die "cannot move $file to /opt/pdadmin/queue/done/"; 
       close FILE; 
   }
}
close LOCK;
