#!/usr/local/pd-admin2/bin/perl -w

use strict;
use DBI;
use Fcntl ':flock';

#####
##### Read Configuration
#####

use vars qw($popuser_name $dsn $user $password $domainfile $apacherestart
            $popuser_id $popuser_gid $pop3_root @dotqmail_special);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't do it: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

my $query = "select t1.login, t1.localpart, t3.name, t4.login ".
            "from pop3 as t1, vhosts as t2, domains as t3, users as t4 ".
            "where t1.vhost=t2.id and ".
            "t2.domain=t3.id and t3.owner=t4.id";

my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv  = $sth->execute or die "cannot execute query '$query'";

while (my ($username, $localpart, $domain, $loginid) = $sth->fetchrow_array) {
    unless (-e "/home/popuser/popboxen/$domain/$username/.qmail") {
        open QMAIL, ">/home/popuser/popboxen/$domain/$username/.qmail"
              or warn "ERROR:310:/home/popuser/popboxen/$username/.qmail:$!";
        flock QMAIL, LOCK_EX;
        print QMAIL "|/home/popuser/spamfilter.pl\n" if (-e "/home/popuser/spamfilter.pl");
        print QMAIL "|/home/popuser/mailquotacheck.sh\n" if (-e "/home/popuser/mailquotacheck.sh");
        print QMAIL map "$_\n", @dotqmail_special if (scalar @dotqmail_special > 0);
        print QMAIL "/home/popuser/popboxen/$domain/$username/Maildir/\n";
        close QMAIL;
        system "chown popuser:popuser /home/popuser/popboxen/$domain/$username/.qmail"
    }
}
$sth->finish;
