#!/usr/local/pd-admin2/bin/perl -w

use strict;
use Quota;

use vars qw($quota_dev $quota_blocks_per_kb);
do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't read configuration: $!";

my $user  = shift;
die "usage: $0 <username>\n" unless (defined $user and $user =~ /^\w+$/);

my ($uid) = (getpwnam($user))[2];
die "no such user: $user\n" unless (defined $uid and $uid =~ m/^\d+$/);

my ($block_curr)       = Quota::query($quota_dev, $uid, 0) or die "$!";
$quota_blocks_per_kb ||= 1; 

print $block_curr * $quota_blocks_per_kb, "\n";
