#!/usr/local/pd-admin2/bin/perl -w

use strict;
use DBI;

####
####   read configuration
####

use vars qw ($dsn $user $password $proftpd_logfile);
do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't read configuration: $!";

####
####   database connection
####

my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

####
####   subroutines 
####

sub get_row($) {
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

sub update_row {
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}

####
####   main
####

$proftpd_logfile ||= '/var/log/xferlog';

die "no logfile $proftpd_logfile!\n" unless (-e $proftpd_logfile);

my $time = time;


system "chmod 600 $proftpd_logfile";
rename $proftpd_logfile, "$proftpd_logfile.$time" or die "cannot rename $proftpd_logfile: $!";
system "killall -HUP proftpd";
system "chmod 600 $proftpd_logfile";

open XFERLOG, "$proftpd_logfile.$time" or die "$proftpd_logfile.$time: $!\n";

my %traffic;
while (<XFERLOG>) {
   my ($bytes, $file, $type) = (split /\s+/)[7,8,11];
   next if (defined $type and $type eq 'd');
   if ($file =~ m:home/([^/]+):) {
      $traffic{$1} ||= 0;
      $traffic{$1}  += $bytes;
   }
}

for (keys %traffic) {

   my ($dbuid) = get_row "select id from users where login='$_'";

   print "$_ -> $dbuid\n";

   if (defined $dbuid) {
      my $query  = "select id from traffic_new where id_user='$dbuid' and date=now();";
      my $sth    = $dbh->prepare($query) or die "cannot prepare query '$query'";
      my $rv     = $sth->execute or die "cannot execute query '$query': $dbh:errorstr";
      my $rows   = $sth->rows;
      $sth->finish;
      $traffic{$_} = 0 unless (defined $traffic{$_} and $traffic{$_} =~ /^\d+$/ );
      if (defined $rows and $rows) {
         $query = "update traffic_new set ftp=ftp+$traffic{$_} where id_user='$dbuid' and date=now();";
      } else {
         $query = "insert into traffic_new set ftp='$traffic{$_}', id_user='$dbuid', date=now();";
      }
      unless (update_row $query) {
         warn "Kann Traffic fuer $_ nicht in die Datenbank schreiben!\n$query\n\n";
      }
   }

}

system "gzip $proftpd_logfile.$time";
