#!/usr/local/pd-admin2/bin/perl -w

#################################################################
#####
#####   pd-admin - subdomain.pl 3.x
#####   (c) 1999 - 2007 by Daniel Bradler
#####  
#################################################################

$<=$>; $| = 0; # Buffer flushen

use strict;
use IO::File;
use DBI;
use PDPASSWD;

#####
#####   V A R s
#####

$ENV{PATH}         = '/usr/local/bin:/usr/bin:/bin';

use vars qw($dsn $user $password $server_hostname);
  
do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration file: $!";

my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

#######################
sub get_row($) {
#######################
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'\n";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

#######################
sub update_row {
#######################
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}


####
####  Main
####


my ($hostname) = get_row 'select varvalue from config where varname="server_hostname"';

my $arg = shift;

if (defined $arg and $arg eq '-c') {
    print $server_hostname, "\n";
    exit
}

unless (defined $hostname and length $hostname) {
   $hostname = $server_hostname;
}

print $hostname, "\n";
