#!/usr/local/pd-admin2/bin/perl -w

use strict;
use DBI;

#####
##### Read Configuration
#####

use vars qw($popuser_name $dsn $user $password $domainfile $apacherestart);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration file: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

my @lines;
my $query = "select t1.name, t1.vhostroot from domains as t1, users as t2 ".
            "where t1.owner=t2.id and t2.suspended='0'";

my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv  = $sth->execute or die "cannot execute query '$query'";
while (my @rueck = $sth->fetchrow_array) {
  push @lines, join ' ', @rueck;
}
$sth->finish;

open DOMAINS, ">$domainfile.$$" or die "$domainfile.$$: $!";
flock DOMAINS, 2;

system 'chgrp', 'www', "$domainfile.$$";
chmod 0640, "$domainfile.$$";

while ($_ = shift @lines) {
  print DOMAINS $_, "\n";
}

$query = "select name from codomains;";
$sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
$rv  = $sth->execute or die "cannot execute query '$query'";
while (my ($codomain) =  $sth->fetchrow_array) {
  print DOMAINS "$codomain /home/codomain/codomain.php/\n"
}

close DOMAINS;

rename "$domainfile.$$", $domainfile or die "cannot rename $domainfile.$$: $!";
