#!/usr/local/pd-admin2/bin/perl -w

use strict;
use Data::Dumper;

sub error_logs ()
{
   opendir (my $dh, '/home/errorlogs') or die "opendir failed: $!";
   my @result = 
      grep { -f $_ }
      map { ("/home/errorlogs/$_/error_log", glob "/home/errorlogs/$_/php-fpm-*.log") }
      grep { /\A[a-z0-9]{8,8}\z/ }
      readdir ($dh);
   return @result;
}

my @logs = ('/usr/local/pd-admin2/errorlogs/error_log',
            '/usr/local/pd-admin2/logs/error_log',
            '/usr/local/apache/logs/error_log');

push @logs, error_logs ();

for my $log (@logs) {
   if (-e $log) {
      my ($bytes) = -s $log;
      if ($bytes > 500000) {
         my $time = time;
         rename $log, "$log.$time" or die "cannot rename $log: $!";
         if (-f '/usr/bin/lz4') {
            system ('lz4', "$log.$time", "$log.$time.lz4");
            unlink ("$log.$time") if -f "$log.$time.lz4";
         }
         else {
            system ('gzip',  '-9', "$log.$time");
         }
      }
   }
}

system "killall -USR1 httpd"
