#!/bin/bash

set -e

PHPVERSION=7.4

[ -e ~/bin/composer ] && exit
[ -d ~/bin ] || mkdir ~/bin

cd ~/bin

wget -O ./composer-setup.php https://getcomposer.org/installer

if [ -e ./php ]; then

~/bin/php -d allow_url_fopen=1 ./composer-setup.php \
--filename=composer.phar

cat <<EOF > ~/bin/composer
#!/bin/bash
exec ~/bin/php ~/bin/composer.phar "\$@"
EOF

chmod +x ~/bin/composer
rm -f ./composer-setup.php

echo "Installation von composer abgeschlossen"

else

PS3="Wähle eine PHP Version:"

select version in 7.4 8.0 8.1 8.2
do

PHPVERSION=$version

/usr/local/pd-admin2/bin/php-$PHPVERSION-cli -d allow_url_fopen=1 ./composer-setup.php \
--filename=composer.phar

cat <<EOF > ~/bin/composer
#!/bin/bash
exec /usr/local/pd-admin2/bin/php-$PHPVERSION-cli -c ~/php-cli.ini ~/bin/composer.phar "\$@"
EOF

test -e ~/php-cli.ini || {
   cat /usr/local/pd-admin2/php-$PHPVERSION/lib/php.ini > ~/php-cli.ini
}

chmod +x ~/bin/composer
rm -f ./composer-setup.php

echo "Installation von composer abgeschlossen."
break

done

fi
