#!/usr/local/pd-admin2/bin/perl -w

###
###  pd-admin - httpd_log.pl
###
###  (c) 1999 - 2005 by Daniel Bradler
###

use strict;
use DBI;
use Socket;

###
###  Read Configuration
###

use vars qw($dsn $user $password @nameservers %cmd);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't read configuration: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

###
###  Main
###

unless (scalar @nameservers) {
   if (open RS, '/etc/resolv.conf') {
      while (<RS>) {
        if (/nameserver\s+(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/) {
            push @nameservers, $1;
        } 
      }
   }
}

my $iptables = $cmd{iptables} || 'iptables';

my $query = "select users.uid from users, accounts ".
            "where accounts.network_access='0' and users.account=accounts.id";
my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv  = $sth->execute or die "cannot execute query '$query'";

my @uids;
while (my ($uid) = $sth->fetchrow_array) {
   push @uids, $uid
}
$sth->finish;

system "$iptables -D OUTPUT -o eth0 -j user_traffic";
system "$iptables -N user_traffic";
system "$iptables -F user_traffic";
system "$iptables -A OUTPUT -o eth0 -j user_traffic";
system "$iptables -A user_traffic -m state --state ESTABLISHED,RELATED -p tcp --sport ftp-data -j ACCEPT";

for my $nameserver (@nameservers) {
   system "$iptables -A user_traffic -p udp -d $nameserver --dport domain -j ACCEPT";
}

for my $uid (@uids) {
  system "$iptables -A user_traffic -m owner --uid-owner $uid -j REJECT"
}
