#!/bin/bash
#
#  order-certificate.sh
#  Ticket 1524538
#  2021-11-24 stvo
#
source /usr/local/pd-admin2/SETENV
set -CEeuo pipefail
#set -x

type setuidgid > /dev/null
type env > /dev/null
type uuidgen > /dev/null
type tr > /dev/null
type mysql > /dev/null
type hostname > /dev/null

msg=""
function errorexit ()
{
   echo "$msg" >&2
   exit 1
}
trap 'errorexit' ERR
msg="must be root to execute this script"
[[ $EUID = 0 ]]

msg="Usage: /opt/pdadmin/bin/order-certificate.sh <reseller login> <hostname>"
reseller=${1-}
shift
[[ ! -z $reseller ]]

hostname=${1-}
shift
[[ ! -z $hostname ]]

server_address=$(hostname -i)

export MYSQL_PWD=$(cat /opt/pdadmin/etc/mysql_rootpw.conf)

resellerid=$(mysql -N vadmin -e "select id from resellers where login = \"$reseller\"")
msg="could not find resellerid for reseller <$reseller>"
[[ $resellerid != '' ]]

session=$(uuidgen | tr -d -)
function cleanup_session ()
{
   mysql -N vadmin -e "delete from sessions where session = \"$session\""
}
trap 'cleanup_session' EXIT

mysql -N vadmin -e "insert into sessions (type, session, time, lang, user)
values (\"reseller\", \"$session\", unix_timestamp(), \"de\", $resellerid);"

cmd=(
   setuidgid
      www
      env
         -i
         SERVER_PORT=443
         REQUEST_METHOD=GET
         "QUERY_STRING=todo=ssl.order&hostname=$hostname&lifespan=1&ofile=ssl.order.html"
         REQUEST_URI=sid/$session
         SERVER_ADDR=$server_address
         /opt/pdadmin/www/administrator/administrator.cgi
)
"${cmd[@]}" | grep begin_msg
echo fin
