#!/usr/local/bin/perl -w

use strict;
use IO::Handle;
use DBI;

#####
##### Read Configuration
#####

use vars qw($dsn $user $password);
do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't read configuration: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};


##################
sub get_row($) {
##################
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

##################
sub update_row {
##################
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}

###############################
sub get_mailbox_byid($) {
###############################
   my $id = shift;
   unless (defined $id and $id =~/^(\d+)$/) {
      return
   }
   $id = $1;
   my $query = "select t1.localpart, t2.name, t3.name, t3.idn from pop3 as t1, vhosts as t2, domains as t3 ".
               "where t1.id='$id' and t1.vhost=t2.id and t2.domain=t3.id";
   my ($local, $sub, $domain, $idn) = get_row $query;

   if (defined $sub and length $sub) {
      $idn = "$sub.$idn";
   }

   return unless (defined $local and length $local);
   return "$local\@$idn";
}

#####
##### M A I N
#####

my $login = shift;

unless (defined $login and length $login) {
   print "usage: $0 <loginID|Email-Adresse>\n";
   print "   or: $0 --all\n";
   exit 1;
}

if ($login eq '--all') {
   update_row "update pop3 set suspended='0', warned='0'";
   exit
}

my $query;
if ($login =~ /\@/) {
  my ($localpart, $host) = split /\@/m, $login; 
  $query = "select t1.id from pop3 as t1, vhosts as t2, domains as t3 where localpart='@{[quotemeta $localpart]}' and t1.vhost=t2.id and t2.domain=t3.id and
               t2.name='' and t3.name='@{[quotemeta $host]}';";
} else {
  $query = "select id from pop3 where login='@{[quotemeta $login]}';";
}

my ($id) = get_row $query;

unless (defined $id and $id) {
    die "Mailbox $login not found\n";
}

update_row "update pop3 set suspended='0', warned='0' where id='$id'";

if ($login !~ /\@/) {
  print "Mail account @{[get_mailbox_byid $id]} unsuspended.\n";
} else {
  print "Mail account $login unsuspended.\n";
}
