#!/bin/bash
set -Ceuo pipefail

nuldec=/usr/local/pd-admin2/bin/nuldec
$nuldec <<<'' >/dev/null
type lz4 >/dev/null

function report_errors_and_cleanup_log_tmpdir
{
   cat $log_tmpdir/TAR.STDOUT
   exec 1<&-
   cat $log_tmpdir/TAR.STDERR >&2

   rm -fr "$log_tmpdir" 2>/dev/null || true
}

tmpdir=$1
shift
[[ $tmpdir ]]

log_tmpdir=$(mktemp -d "/tmp/popuser.import.XXXXXX")
trap "report_errors_and_cleanup_log_tmpdir" EXIT

(
   cd "$tmpdir"
   chown popuser .
   $nuldec | setuidgid popuser tar -Ilz4 -x || exit $?
   find . -type l -exec rm {} \;
) >$log_tmpdir/TAR.STDOUT 2>$log_tmpdir/TAR.STDERR
