#!/bin/bash
#
#  2017-05-30 stvo
#
source /usr/local/pd-admin2/SETENV
set -Ceu
if [ "$BASH_VERSINFO" -ne "2" ]; then
   set -o pipefail
fi
#set -x

active=/service
susp=/service.suspended
mkdir -p $susp

function write_apache24_runfile
{
   local filename=$1
   echo "#!/bin/bash" >| $filename
   cat >> $filename <<'_'

if [ ! -e "/etc/real-hostname" ]; then
  hostname $(/opt/pdadmin/bin/hostname.pl)
else
  hostname $(cat /etc/real-hostname)
fi

killall -9 httpd >/dev/null 2>&1
rm /usr/local/pd-admin2/httpd-2.4/logs/httpd.pid
ulimit -n 64000
cmd=(
   exec /usr/local/pd-admin2/httpd-2.4/bin/httpd 
      -D NO_DETACH 
      -DSSL
)
"${cmd[@]}"
_
}

function write_apache24_runfile_and_create_symlink
{
   local base=$1
   write_apache24_runfile $base/apache24/run-v2
   chmod +x $base/apache24/run-v2
   rm -f $base/apache24/run
   ln -s run-v2 $base/apache24/run
}

function create_apache24_service_dir
{
   mkdir -p $susp/apache24
   write_apache24_runfile_and_create_symlink $susp
}

function refresh_apache24_runfile
{
   if [ -f /service/apache24/run-v2 -a -L /service/apache24/run ]
   then
      return
   fi
   echo "AP24: creating run-v2, symlinking to run"
   write_apache24_runfile_and_create_symlink $active
   svc -du $active/apache24
}

function disable
{
   v=$1
   mv $active/apache$v $susp/
   (
      sleep 1
      svc -dx $susp/apache$v
   )&
   echo "disabled apache$v"
}

function enable
{
   v=$1
   mv $susp/apache$v $active/
   echo "enabled apache$v"
}

webserver=${1:-AP24}
echo "webserver = <$webserver>"
case $webserver in
   AP24)
      if [ -d $active/apache24 ]; then
         echo "Apache 24 is already selected"
         refresh_apache24_runfile
         exit
      fi
      create_apache24_service_dir
      enable 24
      disable ''
      ;;
   *)
      echo "webserver must be AP24"
      exit 1
      ;;
esac
