#!/usr/local/pd-admin2/bin/perl

use strict;
use DBI;
use Fcntl ':flock';

####
####  defaults
####

my $maillog = shift;
$maillog ||= '/var/log/mail';

####
####  Main
####

$| = 1;
my %msg; my %delivery; my %traffic;
my $msgs_total = 0;
while (<>) {

    chomp;

    if (/info msg (\d+): bytes (\d+) from <([^>]*)> qp \d+ uid (\d+)/) {
        my $msgid = $1;
        my $bytes = $2;
        my $from  = lc $3;
        my $uid   = $4;

        my $owner;

        $msg{$msgid}{bytes} = $bytes;
        $msg{$msgid}{from}  = $from;

    }

    if (/end msg (\d+)/) {
       my $msgid = $1;
       for my $deliveryid (@{$msg{$msgid}{deliveries}}) {
          next unless (defined $msgid);
          $msg{$msgid}{from} ||= '';
          $msg{$msgid}{delivery}{$deliveryid}{rpct} ||= '';
          $msgid ||= 0;
          $deliveryid ||= 0;
          $msg{$msgid}{bytes} ||= 0;
          print "@{[scalar localtime $delivery{$deliveryid}{timestamp}]}  from: <$msg{$msgid}{from}>, to: <$msg{$msgid}{delivery}{$deliveryid}{rpct}>, msg-id $msgid, delivery-id: $deliveryid, bytes $msg{$msgid}{bytes}\n";
          unless (defined $msg{$msgid}{bytes}) {
              $msg{$msgid}{bytes}  = 0;
          }
          if (defined $delivery{$deliveryid}{status} and $delivery{$deliveryid}{status}) {
              # Zustellung erfolgreich
          }
          delete $delivery{$deliveryid};
       }
       delete $msg{$msgid};
    }   


    if (/(\d+)\.\d+ starting delivery (\d+): msg (\d+).* (\S+\@\S+)/) {
        my $timestamp = $1;
        my $deliveryid = $2;
        my $msgid = $3;
        my $rcpt  = lc $4;

        $msg{$msgid}{delivery}{$deliveryid}{rpct} = $rcpt;

        push @{$msg{$msgid}{deliveries}}, $deliveryid;
        $delivery{$deliveryid}{msgid} = $msgid;
        $delivery{$deliveryid}{timestamp} = $timestamp;
    }

    if (/delivery (\d+): success/) {
        $delivery{$1}{status} = 1;
    }
         
}
