#!/usr/local/pd-admin2/bin/perl -w

use strict;

####
####  pd-Admin 4.x - awstats-Modul
####  (c) 2002 - 2007 by Daniel Bradler
####

use strict;
use DBI;

####
####  configuration
####

chdir '/home';

use vars qw($dsn $user $password $awstats $awstats_dir $awstats_icons 
            $awstats_plugins $awstats_lib $awstats_lang $awstats_cgi);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$dbh->{InactiveDestroy} = 1;
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

exit if (defined $awstats_cgi and $awstats_cgi eq '---');

if (-e '/usr/local/pd-admin2/awstats/wwwroot/icon/') {
   $awstats_icons ||= '/usr/local/pd-admin2/awstats/wwwroot/icon/';
}

if (-e '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/lib/') {
   $awstats_lib ||= '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/lib/';
}

if (-e '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/plugins/') {
   $awstats_plugins ||= '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/plugins/';
}

if (-e '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/lang/') {
   $awstats_lang ||= '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/lang/';
}

if (-e '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/awstats.pl') {
   $awstats_cgi ||= '/usr/local/pd-admin2/awstats/wwwroot/cgi-bin/awstats.pl';
}

$awstats_icons ||= '/opt/pdadmin/etc/awstats';

####
####   S U B s
####

###############################
sub get_row($) {
###############################
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'\n";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}


###############################
sub config($) {
###############################
   my $var = shift;
   my ($value) = get_row "select varvalue from config where varname='$var'";
   return $value if (defined $value and length $value);
}

###############################
sub get_login($) {
###############################
  my $id = shift;
  my $query = "select login from users where id='$id'";
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot exucte query '$query'";
  my ($loginid) = $sth->fetchrow_array;
  $sth->finish;
  return $loginid;
}

###############################
sub getdbuid($) {
###############################
  my $loginid = shift;
  my $query = "select id from users where login='$loginid'";
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot exucte query '$query'";
  my ($id) = $sth->fetchrow_array;
  $sth->finish;
  return $id;
}

my $awstats_mode = config('awstats_mode');

###############################
sub awstats($$$$$) {
###############################

  my $conf     = shift;
  my $hostname = shift;
  my $logpath  = shift;
  my $htdocs   = shift;
  my $user     = shift;

  $ENV{AWSTATS} = $awstats;
  $ENV{STATS}   = $htdocs;

  $conf =~ s/\$\$logfile_path/$logpath/g;
  $conf =~ s/\$\$stats_path/$htdocs/g;
  $conf =~ s/\$\$hostname/$hostname/g;

  unless (-d $htdocs) {
    if (mkdir $htdocs, 0755 or warn "$htdocs: $!") {
       system "chown $user:$user $htdocs"
    }
  }

  my ($user_has_cgi) = get_row "select cgi from users,accounts where users.login='@{[quotemeta $user]}' and users.account=accounts.id";

  open CONF,">/etc/awstats/awstats.conf" or die "awstats.conf: $!";
  print CONF $conf;
  close CONF;
  my $pid = fork;
  if (defined $pid) {
    unless ($pid) {
      $SIG{__DIE__} = sub { die @_; };
      my ($uid, $gid) = (getpwnam($user))[2,3];
      $( = $gid; $) = $gid; $< = $uid; $> = $uid;

      system "mkdir -p $htdocs";

      unless (-d "$htdocs/icon") {
        mkdir "$htdocs/icon", 0755 or warn "$htdocs/icon: $!";
      }
      system "cp -r $awstats_icons/. $htdocs/icon/";

      if (defined $awstats_mode and $awstats_mode eq 'cgi' and $user_has_cgi) {

          unless (-d "$htdocs/lib") {
            mkdir "$htdocs/lib", 0755 or warn "$htdocs/lib: $!";
          }
          unless (-d "$htdocs/plugins") {
            mkdir "$htdocs/plugins", 0755 or warn "$htdocs/plugins: $!";
          }
          unless (-d "$htdocs/lang") {
            mkdir "$htdocs/lang", 0755 or warn "$htdocs/lang: $!";
          }
          system "chmod -R u+w $htdocs";
          system "cp /etc/awstats/awstats.conf $htdocs/awstats.conf";
          system "cp $awstats_cgi $htdocs/awstats.cgi" if (defined $awstats_cgi and length $awstats_cgi);
          system "cp -r $awstats_plugins/. $htdocs/plugins/" if (defined $awstats_plugins and length $awstats_plugins);
          system "cp -r $awstats_lib/. $htdocs/lib/" if (defined $awstats_lib and length $awstats_lib);
          system "cp -r $awstats_lang/. $htdocs/lang/" if (defined $awstats_lang and length $awstats_lang);
      }
      system "/opt/pdadmin/bin/stats_awstats.sh";
      if (defined $awstats_mode and $awstats_mode eq 'cgi' and $user_has_cgi) {
          open INDEX, ">$htdocs/index.html" or die "$!";
          print INDEX <<HTML;
         <html>
            <head>
               <title>Statistik fuer $hostname</title>
            </head>
            <frameset cols="100%,*" border="0" frameborder="0">
              <frame src="awstats.cgi" scrolling="auto" name="frame" noresize>
            </frameset>
         </html>
HTML
         close INDEX;
      }
      exit;

    }  else {
       waitpid $pid,0
    }
  } else {
      warn "Couldn't fork child process."
  }

}

####
####  M A I N
####

unless (defined $awstats and length $awstats and -e $awstats and -x $awstats) {
    die 'Sie haben die Konfigurationsvariable $awstats nicht richtig gesetzt!'. "\n";
}

$awstats_dir ||= 'awstats'; 

unless (-d '/etc/awstats') {
   mkdir '/etc/awstats', 0755 or die "cannot mkdir /etc/awstats\n";
}

open CONF, "/opt/pdadmin/etc/awstats.conf.master" or die "awstats.conf.master: $!";
my $masterconf = join "", <CONF>;
close CONF;

my $query = "select t1.name, t1.vhostroot, t2.name, t1.owner, t2.target, t2.awstats_dir from domains ".
            "as t1, vhosts as t2, users as t3 where t2.domain=t1.id and t1.owner=t3.id ".
            "and t3.awstats='on';";

my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv  = $sth->execute or die "cannot execute query '$query'";

while (my @row = $sth->fetchrow_array) {

   my $domain;
   my $owner = $row[3];

   if (defined $row[2] and length $row[2]) {
      $domain = "$row[2].$row[0]";
   } else {
      next;
   }
   my $user  = get_login $owner;
   next unless (defined $user and defined $user);
   
   my $home  = (getpwnam $user)[7];
   next unless (defined $home and defined $home);
   my $log    = "$home/logs/$domain-access.log";

   my $htdocs;
   my $target = $row[4];
   if (defined $row[5] and length $row[5]) {
      $htdocs = "$row[1]/$row[5]"
   } else {
      if (defined $target and length $target and $target !~ m!^https?://!) {
         if ($target ne "$row[1]/$domain") {
            $htdocs = "$target/$awstats_dir/$domain";
         } else {
            $htdocs = "$row[1]/$domain/$awstats_dir";
         }
      } else {
         $htdocs = "$row[1]/$domain/$awstats_dir";
      }
   }


   if (-e $log) {

     print "Bearbeite: $domain\n";

     awstats $masterconf, $domain, $log, $htdocs, $user;

   }
}
$sth->finish;
