#!/bin/bash

RRDTOOL=/usr/bin/rrdtool
RRDBASE=/opt/pdadmin/tmp/rrd
RRDGRAPH=$RRDBASE/graphs

mkdir -p $RRDBASE && chown pdadmin:pdadmin $RRDBASE
mkdir -p $RRDGRAPH && chown pdadmin:pdadmin $RRDGRAPH

PATH=/sbin:/usr/sbin:/usr/local/sbin:/root/bin:/usr/local/bin:/usr/bin:/bin

case $1 in (create)
		$RRDTOOL create $RRDBASE/load.rrd -s 300 \
                DS:load5:GAUGE:600:0:500 \
                DS:load15:GAUGE:600:0:500 \
                RRA:AVERAGE:0.5:1:2016 \
                RRA:AVERAGE:0.5:12:4380

                ;;

	(update)

                test -e $RRDBASE/load.rrd || bash $0 create
                LOAD=`awk '{print $2":"$3}' < /proc/loadavg`
		$RRDTOOL update $RRDBASE/load.rrd N:$LOAD
                chown pdadmin:pdadmin $RRDBASE/load.rrd;;

	(graph)
		$RRDTOOL graph $RRDGRAPH/load_day.png \
		-Y -L 5 -v "Load" -w 538 -h 90 -t "Load Average 'Last Day'" \
		-c ARROW\#000000 -x MINUTE:30:HOUR:1:HOUR:1:0:%H \
		DEF:load5=$RRDBASE/load.rrd:load5:AVERAGE \
		DEF:load15=$RRDBASE/load.rrd:load15:AVERAGE \
		HRULE:1\#000000 \
		COMMENT:"	\j" \
		COMMENT:"  " \
		AREA:load5\#3581ff:"Load average 5min" \
		LINE1:load15\#000000:"Load average 15min" \
		COMMENT:"	\j" 

                $RRDTOOL graph $RRDGRAPH/load_week.png \
                -s "-1w" -Y -L 5 -v "Load" -w 538 -h 90 -t "Load Average 'Last Week'" \
                -c ARROW\#000000 -x HOUR:8:DAY:1:DAY:1:0:%d. \
                DEF:load5=$RRDBASE/load.rrd:load5:AVERAGE \
                DEF:load15=$RRDBASE/load.rrd:load15:AVERAGE \
                HRULE:1\#000000 \
                COMMENT:"       \j" \
                COMMENT:"  " \
                AREA:load5\#3581ff:"Load average 5min" \
                LINE1:load15\#000000:"Load average 15min" \
                COMMENT:"       \j" 

                $RRDTOOL graph $RRDGRAPH/load_month.png \
                -s "-1m" -Y -L 5 -v "Load" -w 538 -h 90 -t "Load Average 'Last Month'" \
                -c ARROW\#000000 -x DAY:1:WEEK:1:WEEK:1:0:Week%W \
                DEF:load5=$RRDBASE/load.rrd:load5:AVERAGE \
                DEF:load15=$RRDBASE/load.rrd:load15:AVERAGE \
                HRULE:1\#000000 \
                COMMENT:"       \j" \
                COMMENT:"  " \
                AREA:load5\#3581ff:"Load average 5min" \
                LINE1:load15\#000000:"Load average 15min" \
                COMMENT:"       \j" 

                chown pdadmin:pdadmin $RRDBASE/graphs/*;;
	(*)
		echo "Invalid option.";;
esac
