#!/usr/local/pd-admin2/bin/perl -w

#################################################################
#####
#####   pd-admin - subdomain.pl 3.x
#####   (c) 1999 - 2007 by Daniel Bradler
#####  
#################################################################

$<=$>; $| = 0; # Buffer flushen

use strict;
use IO::File;
use DBI;
use PDPASSWD;

#####
#####   V A R s
#####

$ENV{PATH}         = '/usr/local/bin:/usr/bin:/bin';

use vars qw($dsn $user $password);
  
do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration file: $!";

my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

#######################
sub get_row($) {
#######################
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'\n";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

#######################
sub update_row {
#######################
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}


#########################
sub subdomains_create {
#########################


  my $domain    = shift;
  my $subdomain = shift;

  ($domain) = $domain =~ /^([a-z0-9.-]+)$/ or die "Ungueltige Domain\n";
  ($subdomain) =~ $subdomain =~ /^([a-z0-9.-]+)$/ or die "Ungueltige Subdomain\n";


  my $query = "select t1.id, t1.owner, t1.vhostroot, t2.uid, t2.gid from domains as t1, ".
              "users as t2 where t1.name='$domain' and t2.id=t1.owner;";
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my ($id, $owner, $vroot, $uid, $gid) = $sth->fetchrow_array;
  $sth->finish;

  unless (defined $id and $id) {
     die "Domain $domain unbekannt\n";
  }
  my ($vtest) = get_row "select id from vhosts where name='$subdomain' and domain='$id'";
  if (defined $vtest and $vtest) {
      die "Subdomain existiert bereits.\n";
  }

  ($vroot)   = $vroot   =~ m/^(\/[\w\/\.-]+)$/ or die "Ungueltiges VHost-Rootdirectory\n";
  ($uid) = $uid =~ m/^(\d+)$/ or die "Ungueltige UID\n";
  ($gid) = $gid =~ m/^(\d+)$/ or die "Ungueltige GID\n";

  my $dir = "$subdomain.$domain";
  $query  = "insert into vhosts (name, domain) VALUES ('$subdomain', '$id');";
  update_row($query) or die "Konnte Subdomain nicht in die Datenbank einfuegen.\n";

  system "/opt/pdadmin/bin/httpd_vhosts.pl 2>&1 >/dev/null";

  $( = $gid; $) = $gid; $< = $uid; $>=$uid;
  unless (-d "$vroot/$dir") {
    mkdir "$vroot/$dir", 0755 or die "$vroot/$dir: $!\n";
    open INDEX, ">$vroot/$dir/index.html";
    print INDEX "
<html>
<header>
<title>$subdomain.$domain</title>
</header>
<body>
<p align=center>$subdomain.$domain</p>
<p align=center>Hier entsteht eine neue Webpr&auml;senz!</p>
</body>
</html>";
    close INDEX;
  }
  print "Subdomain eingerichtet\n";
}

#########################
sub subdomains_delete {
#########################


  my $domain    = shift;
  my $subdomain = shift;

  ($domain) = $domain =~ /^([a-z0-9.-]+)$/ or die "Ungueltige Domain\n";
  ($subdomain) =~ $subdomain =~ /^([a-z0-9.-]+)$/ or die "Ungueltige Subdomain\n";


  my $query = "select t1.id, t1.owner, t1.vhostroot, t2.uid, t2.gid from domains as t1, ".
              "users as t2 where t1.name='$domain' and t2.id=t1.owner;";
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my ($id, $owner, $vroot, $uid, $gid) = $sth->fetchrow_array;
  $sth->finish;

  unless (defined $id and $id) {
     die "Domain $domain unbekannt\n";
  }

  my ($vtest) = get_row "select id from vhosts where name='$subdomain' and domain='$id'";
  unless (defined $vtest and $vtest) {
      die "Subdomain existiert nicht.\n";
  }

  ($vroot)   = $vroot   =~ m/^(\/[\w\/\.-]+)$/ or die "Ungueltiges VHost-Rootdirectory\n";
  ($uid) = $uid =~ m/^(\d+)$/ or die "Ungueltige UID\n";
  ($gid) = $gid =~ m/^(\d+)$/ or die "Ungueltige GID\n";

  my $dir = "$subdomain.$domain";
  $query  = "delete from vhosts where id='$vtest'";
  update_row($query) or die "Konnte Subdomain aus der Datenbank loeschen.\n";

  system "/opt/pdadmin/bin/httpd_vhosts.pl 2>&1 >/dev/null";

  $( = $gid; $) = $gid; $< = $uid; $>=$uid;
  system "cd $vroot/$dir && rm -R $vroot/$dir";
  print "Subdomain gelscht\n";
}


####
####
####  Main
####
####

my $command = shift;

if (defined $command and $command eq 'create') {
    subdomains_create shift, shift;
    exit 0
}
if (defined $command and $command eq 'delete') {
    subdomains_delete shift, shift;
    exit 0
} 

exit 11
