//
// 2016-08-16 stvo
// bkbargraph.js
// $Id$
//

var color_http = "rgb(217, 83, 79)";
var color_free = "rgb(240, 173, 78)";
var color_mail = "rgb(91, 192, 222)";
var color_ftp = "rgb(92, 184, 92)";
var itemcolor = [
   color_http,
   color_ftp,
   color_mail,
   color_free
];

var GENERATE_TESTDATA = false;

var barwidth = 19;
var xoffset = 1 * barwidth;
var xgridwidth = 2 * barwidth + 8;
var barheight = 150;
var yoffset = 20;
var xbaradjustment = -barwidth / 2; // center over text

function x_of_i(i)
{
   return xoffset + i * xgridwidth;
}

function create_random_data()
{
   var a = new Array(12);
   for (var i = 0; i < 12; ++i) {
      var b = new Array(4);
      for (var j = 0; j < 4; ++j)
         b[j] = 20 * Math.random() + 0.001;
      a[i] = {
         tag: "TESTDATEN!+++"[i],
         values: b,
      };
   }
   return a;
}

function compute_max(r)
{
   var max = 0;
   for (i = 0; i < r.length; ++i) {
      var sum = 0;
      for (j = 0; j < 4; ++j) {
         var v = r[i].values[j] + 0.;
         if (v == undefined)
            throw "v undefined";
         if (! (v >= 0))
            throw "v is not nonnegative <" + v + "> (i, j) = (" + i + ", " + j + ")";
         sum += v;
      }
      max = sum > max ? sum : max;
   }
   return max;
}

function draw(canvas, data)
{
   var ctx = canvas.getContext('2d');
   ctx.textAlign = 'center';
   var r;
   if (GENERATE_TESTDATA)
      r = create_random_data();
   else
      r = data;
   var max = compute_max (r);
   if (c.height < barheight)
      throw "canvas not high enough";

   for (var i = 0; i < r.length; ++i) {
      var x = x_of_i(i);
      var ystart = barheight + yoffset;
      var sum = 0;
      for (var j = 0; j < 4; ++j) {
         ctx.fillStyle = itemcolor[j];
         t = r[i].values[j];
         sum += t;
         var y = Math.floor(t / max * barheight);
         ctx.fillRect (x + xbaradjustment, ystart - y, barwidth, y);
         ystart -= y;
      }
      ctx.fillStyle = "rgb(0,0,0)";
      var tag = r[i].tag;
      ctx.fillText(tag, x, barheight + 16 + yoffset);
      ctx.fillText(sum.toFixed(2), x, 16);
   }
}
