//
// session_persistent_selection.js
//
// 2017-04-11 stvo
//

var rdebug = false;

function store_form_element_state (k, v)
{
   if (sessionStorage)
      sessionStorage.setItem(k, v);
   else
      console.log ("no sessionStorage, could not store k = <" + k 
         + ">, v = <" + v + ">");
}

function retrieve_form_element_state (k)
{
   if (sessionStorage)
      return sessionStorage.getItem(k);
   else {
      console.log ("no sessionStorage, could not retrieve k = <" + k 
         + ">");
      return null;
   }
}

function first_element_by_name (name)
{
   var tblsel = document.getElementsByName(name);
   if (tblsel.length < 1)
      throw "no element <" + name + "> found";
   return tblsel[0];
}

function discard_exception (f)
{
   try {
      return f();
   }
   catch (e) {
      if (rdebug)
         console.log ("caught and discarded exception <" + e + ">");
   }
   return null;
}

function dispatch (el, evname)
{
   if (rdebug)
      console.log ("dispatching <" + evname + "> on element <" 
         + el.name + ">");
   var ev = new Event (evname);
   el.dispatchEvent (ev);
}

function abstract_select_element_session_persistence (element_name, 
      additional_element)
{
   var select_element = first_element_by_name (element_name);
   var fev;
   if (fev = retrieve_form_element_state (element_name)) {
      if (select_element.value != fev) {
         select_element.value = fev;
         if (additional_element)
            dispatch (additional_element, 'change');
         else
            dispatch (select_element, 'change');
      }
   }
   else {
      if (rdebug)
         console.log ("no stored value for " + element_name + " found");
   }
   select_element.addEventListener('change', function () {
      store_form_element_state (element_name, this.value);
   });
}

$(document).ready(function () {
   false && discard_exception (
      function () {
         form_to_change = first_element_by_name ('form2');
         abstract_select_element_session_persistence ('search_domain', 
            form_to_change);
      });
   discard_exception (
      function () {
         abstract_select_element_session_persistence ('table1_length');
      });
});
