#!/usr/local/pd-admin2/bin/perl -w

#####
#####  pd-admin 3.0 - get_passwords_from_shadow.pl
#####  (c) 1999 - 2004 by Daniel Bradler
#####

use strict;
use DBI;

#####
#####  database connection 
#####

use vars qw($dsn $user $password);

if (-e "/etc/admin/config.pl") {
   do "/etc/admin/config.pl" or die "Can't execute configuration: $!";
} elsif (-e "/opt/pdadmin/etc/pdadmin.conf") {
   do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration: $!";
} else {
   die "Konfigurationsdatei nicht gefunden!\n";
}

my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

#####
##### predeclared subs
#####

sub get_row($) {
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

sub update_row($) {
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}

#####
#####  Main
#####

my %passwd;
open SHADOW, '/etc/shadow' or die "/etc/shadow: $!";
while (defined (my $shadow = <SHADOW>)) {
   my ($login, $passwd) = split /:/, $shadow;
   $passwd{$login} = $passwd;
}
 
my $query = "select id, login from resellers";
my $sth   = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv    = $sth->execute or die "cannot execute query '$query'";

while (my ($id, $login) = $sth->fetchrow_array) {
    update_row "update resellers set passwd='$passwd{$login}' where id='$id'";
}
$sth->finish;

$query = "select id, login from users";
$sth   = $dbh->prepare($query) or die "cannot prepare query '$query'";
$rv    = $sth->execute or die "cannot execute query '$query'";

while (my ($id, $login) = $sth->fetchrow_array) {
    if (defined $passwd{$login} and length $passwd{$login}) {
        update_row "update users set passwd='$passwd{$login}' where id='$id'";
    }
}
$sth->finish;
