#!/usr/local/pd-admin2/bin/perl -w

#####
#####  PD-Admin 2.0 - prepare_mysql_for_ci.pl
#####  (c) 1999 - 2002 by Daniel Bradler
#####

use strict;
use DBI;

#####
#####  database connection 
#####

use vars qw($dsn $user $password);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

#####
##### predeclared subs
#####

sub get_row($) {
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

sub update_row($) {
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}

#####
#####  Main
#####

my ($uid, $gid) = (getpwnam('popuser'))[2,3];
update_row "alter table pop3 add uid int(10) unsigned DEFAULT '$uid' not null;";
update_row "alter table pop3 add gid int(10) unsigned DEFAULT '$gid' not null;";
update_row "update pop3 set uid='$uid', gid='$gid';";
