#!/usr/local/pd-admin2/bin/perl -w

#####
#####  PD-Admin 2.0 - quota.pl
#####  (c) 1999 - 2002 by Daniel Bradler
#####

use strict;
use DBI;

#####
#####  database connection 
#####

use vars qw($dsn $user $password);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

#####
##### predeclared subs
#####

sub get_row($) {
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

sub update_row($) {
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}

sub test_master($){
   my $master = shift;
   unless (defined $master and $master =~ /^\w+$/) {
      print "LoginID enthaelt ungueltige Zeichen!\n\n";
      return 
   }

   my ($id) = get_row "select id from resellers where login='$master'";
   unless (defined $id and $id) {
      print "Reseller-Account existiert nicht!\n\n";
      return
   }

   return $master;
}

#####
#####  Main
#####

unless (defined $ARGV[0] and $ARGV[0] eq '--force') {
   my ($count_master) = get_row "select count(1) from resellers where master='1'";
   if (defined $count_master and $count_master) {
      exit;
   }
}

print "\n\n";
my $answer = '';
while (lc $answer ne 'j' and $answer ne 'n') {
   print "Wollen Sie ein Update der Reseller-Struktur vornehmen? (j/n): ";
   $answer = <STDIN>;
   chomp $answer;
}
exit if ($answer eq 'n');

my $master;

print "LoginID Master-Reseller: ";
$master = <STDIN>;
while (not test_master $master) {
   print "LoginID Master-Reseller: ";
   $master = <STDIN>;
   chomp $master;
}

my ($masterid) = get_row "select id from resellers where login='$master'";

update_row "update resellers set master='1' where login='$master'";
update_row "update resellers set superreseller=$masterid where login !='$master'";

my @default_priv = qw (user_passwd user_shell user_suspend 
                       hosting_domain_add hosting_domain_del
                       hosting_fp_add hosting_fp_del
                       hosting_codo_add hosting_codo_del);

update_row "delete from privilege";

my $query = "select id, login from resellers";
my $sth   = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv    = $sth->execute or die "cannot execute query '$query'";

while (my ($id, $login) = $sth->fetchrow_array) {
    print "Setze Privilegien fuer $login...\n";
    unless ($id == $masterid) {
       for my $priv (@default_priv) {
           update_row "insert into privilege (user, privilege, status) ".
                      "values ($id, '$priv', '1')";
       }
    }
}
$sth->finish;
