#!/usr/local/pd-admin2/bin/perl -w

use DBI;
use strict;

use vars qw($dsn $user $password);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't do it: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};


#######################
sub update_row {
#######################
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
     if ($sth->execute) {
        $rueck = $sth->{mysql_insertid} || 1;
     }
     $rc = $sth->finish;
  }
  return $rueck;
}


#######################
# Main()
#######################

my $query = "select v.id, v.name, d.name, d.vhostroot, v.target from domains as d, vhosts as v ".
            "where d.id=v.domain and v.name is not null and v.name != ''";

my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv  = $sth->execute or die "cannot execute query '$query'";

while (my ($vid, $subdomain, $domain, $vhostroot, $old_target) = $sth->fetchrow_array) {

   next if (defined $old_target and length $old_target);
   my $documentroot = "$vhostroot/$subdomain.$domain";
   my $new_target = '';
   if (-e "$documentroot/.htaccess") {
      if (open HTACCESS, "$vhostroot/$subdomain.$domain/.htaccess") {
         my $htaccess = join '', <HTACCESS>;
	 if ($htaccess =~ m!^#PD-ADMIN-REDIRECT BEGIN\nRedirect / (.*)\n^#PD-ADMIN-REDIRECT END!m) {
	    $new_target = $1;
	    print "$vhostroot/$subdomain.$domain/.htaccess --> $1\n";
	 }
	 close HTACCESS;
      }
   }
   if (length $new_target) {
      update_row "update vhosts set target='@{[quotemeta $new_target]}' where id='$vid'";
   }

}

$sth->finish;

