#!/usr/local/pd-admin2/bin/perl -w

#####
#####  PD-Admin 2.0 - usrdb.pl
#####  (c) 1999 - 2002 by Daniel Bradler
#####

use strict;
use DBI;

#####
#####  database connection 
#####

use vars qw($dsn $user $password);

do "/opt/pdadmin/etc/pdadmin.conf" or die "Can't execute configuration: $!";
my $dbh = DBI->connect($dsn, $user, $password) or die "can't connect!";
$SIG{__DIE__} = sub {  $dbh->disconnect if $dbh;  die @_;};

#####
##### predeclared subs
#####

sub get_row($) {
  my $query = shift;
  my $sth = $dbh->prepare($query) or die "cannot prepare query '$query'";
  my $rv  = $sth->execute or die "cannot execute query '$query'";
  my @row = $sth->fetchrow_array;
  $sth->finish;
  return @row;
}

sub update_row($) {
  my $query = shift;
  my $rueck = '';
  my ($sth, $rv, $rc);
  if ($sth = $dbh->prepare($query)) {
    if ($sth->execute) {
      $rueck = $sth->{mysql_insertid} || 1;
    }
    $rc = $sth->finish;
  }
  return $rueck;
}

#####
#####  Main
#####

unless (defined $ARGV[0] and $ARGV[0] eq '--force') {
   my ($count_mysql) = get_row "select count(1) from mysqldb";
   if (defined $count_mysql and $count_mysql ) {
      exit;
   }
}

print "\n\n";
my $answer = '';
while (lc $answer ne 'j' and $answer ne 'n') {
   print "Sollen MySQL-Datenbanken uebertragen werden? (j/n): ";
   $answer = <STDIN>;
   chomp $answer;
}
exit if ($answer eq 'n');

my $query = "show databases";
my $sth   = $dbh->prepare($query) or die "cannot prepare query '$query'";
my $rv    = $sth->execute or die "cannot execute query '$query'";

while (my ($db) = $sth->fetchrow_array) {
   if ($db =~ /^usrdb_([a-zA-Z0-9]+)\w*/) {
     print "Bearbeite $db...\n";
     my ($id) = get_row "select id from users where login='$1'";
     if (defined $id and $id) {
        update_row "insert into mysqldb (name, owner) values ('$db', $id)";
     }
  }
}
$sth->finish;
