#!/bin/bash

echo="echo -n"
HERE=`pwd`

myprompt()
{
 answer="##"
 until echo $1 | grep $answer >/dev/null
 do
    $echo "${2} [${3}]?  ${nnl}"
    read answer
    if [ "$3" != "" ] && [ "$answer" = "" ]
    then
       answer=$3
    fi
 done
}

PATH=/usr/local/pd-admin2/bin:/usr/local/bin:$PATH
VERSION=`cat VERSION`
clear
echo "##############################################"
echo "#                                            #"
echo "#  Willkommen beim Update auf pd-admin $VERSION  #"
echo "#                                            #"
echo "##############################################"
echo
echo "Build: `cat BUILD`"
echo

./mysql-update.pl || {
    echo "Kann MySQL-Datenbank nicht anpassen."
    exit 1
}
  
#./tools/reseller-update.pl || {
#    echo "Kann Reseller-Struktur nicht anpassen."
#    exit 1
#}

#test -e /opt/pdadmin && ./tools/usrdb.pl || {
#    echo "Kann Datenbanken nicht uebertragen."
#    exit 1
#}

chown root:root /opt/pdadmin/etc/*
chmod 600 /opt/pdadmin/etc/pdadmin.conf

mkdir -p /usr/local/lib/pdadmin/mysql

grep "^pdadmin:" /etc/group >/dev/null 2>&1 || {
   groupadd pdadmin
}

grep "^pdadmin:" /etc/passwd >/dev/null 2>&1 || {
   useradd pdadmin -g pdadmin -G '' -s /bin/false -d /opt/pdadmin/tmp
}

grep "^pdbackup:" /etc/passwd >/dev/null 2>&1 || {
   useradd pdbackup -G '' -s /bin/false -d /tmp
}

if [ ! -e /usr/local/lib/pdadmin/mysql/mysql.sock ]; then
   if [ -e /tmp/mysql.sock ]; then
      MYSOCK=`./tools/symlink.pl /tmp/mysql.sock`
      ln -s $MYSOCK /usr/local/lib/pdadmin/mysql/mysql.sock
   fi
fi

if [ ! -e /usr/local/lib/pdadmin/mysql/mysql.sock ]; then
   if [ -e /usr/local/pd-admin2/tmp/mysql.sock ]; then
      ln -s /usr/local/pd-admin2/tmp/mysql.sock /usr/local/lib/pdadmin/mysql/mysql.sock
   fi
fi

svc -d /service/qmail-smtpd && killall tcpserver

mkdir -p /opt/pdadmin/lib
chattr -Ri /opt/pdadmin/lib/*.so >/dev/null 2>&1
#cp -a lib/*.so* /opt/pdadmin/lib
chmod 444 /opt/pdadmin/lib/*.so
rm -Rf /opt/pdadmin/lib
cp -a ./pdadmin /opt/
chattr +Ri /opt/pdadmin/lib/*.so >/dev/null 2>&1
cp pdadmin/bin/smtp_greylist.pl pdadmin/bin/smtp_greylist2.pl
mv pdadmin/bin/smtp_greylist2.pl /opt/pdadmin/bin/smtp_greylist.pl

rm -fr /opt/pdadmin/www/assets/ckeditor

chown popuser:popuser /home/popuser
chmod 750 /home/popuser
mkdir -p /home/popuser/whitelists
chown popuser:popuser /home/popuser/whitelists

mkdir -p /opt/pdadmin/log && chmod 750 /opt/pdadmin/log

cp popuser-utils/checkpoppasswd /bin/
touch /bin/checksmtppasswd
chmod 700 /bin/checksmtppasswd 
chown qmaild /bin/checksmtppasswd
XVADMINPW=`perl -e 'do "/opt/pdadmin/etc/pdadmin.conf"; print $password'` 
sed "s/#VADMINPW#/$XVADMINPW/" $HERE/templates/checksmtppasswd-template > /bin/checksmtppasswd

# T#2020072167001507
# touch /home/popuser/mysql_passwd.conf
# chown popuser:popuser /home/popuser/mysql_passwd.conf
# chmod 600 /home/popuser/mysql_passwd.conf
# echo $XVADMINPW > /home/popuser/mysql_passwd.conf

install -g popuser -o popuser popuser-utils/safecat /home/popuser
install -g popuser -o popuser popuser-utils/spamfilter.pl /home/popuser
install -g popuser -o popuser popuser-utils/mailquotacheck.sh /home/popuser
install -g popuser -o popuser popuser-utils/autorespond /home/popuser/autorespond

mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update domains set idn=name where idn is NULL or idn = '';"
mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update codomains set idn=name where idn is NULL or idn = '';"
mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update domains set ipv6=NULL where ipv6='~';"
mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update domains set ipv6_old=NULL where ipv6_old='~';"

# New Mail Quota
mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update accounts set mail_quota=pop3*pop3_quota where mail_quota is null;"
#mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update pop3 p, domains d, vhosts v, users u, accounts a set p.quota=a.pop3_quota where p.vhost=v.id and v.domain=d.id and d.owner=u.id and u.account=a.id;"
mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update pop3 p, domains d, vhosts v, users u, accounts a set p.quota=a.pop3_quota where p.vhost=v.id and v.domain=d.id and d.owner=u.id and u.account=a.id and p.quota is null;"

mkdir -p /opt/pdadmin/tmp
chown pdadmin /opt/pdadmin/tmp
chmod 700 /opt/pdadmin/tmp

mkdir -p /opt/pdadmin/sslcerts
chown -R pdadmin /opt/pdadmin/sslcerts
chmod 700 /opt/pdadmin/sslcerts

test -e /opt/pdadmin/www/customer/index.html && rm /opt/pdadmin/www/customer/index.html
test -e /opt/pdadmin/www/administrator/index.html && rm /opt/pdadmin/www/administrator/index.html

test -e /opt/pdadmin/www/customer/.htaccess || {
    echo "DirectoryIndex customer.cgi" > /opt/pdadmin/www/customer/.htaccess
}

test -e /opt/pdadmin/www/administrator/.htaccess || {
    echo "DirectoryIndex administrator.cgi" > /opt/pdadmin/www/administrator/.htaccess
}

mkdir -p /opt/pdadmin/nav

WWWUSER=`perl -e 'require "/opt/pdadmin/etc/pdadmin.conf"; $wwwuser||='www'; print $wwwuser'`
chown $WWWUSER /opt/pdadmin/nav
chmod 700 /opt/pdadmin/nav

chown -R root:root /opt/pdadmin/www

SERVERID=`perl -e 'require "/opt/pdadmin/etc/pdadmin.conf"; print $server_id'`
DBSERVERID=`perl -e 'require "/opt/pdadmin/etc/pdadmin.conf"; $usrdb_serverhost ||='localhost'; print $usrdb_serverhost'`

if [ "$SERVERID" == "" ]; then
   SERVERID=`hostname`
fi

if [ "$DBSERVERID" == "localhost" ]; then
   DBSERVERID=$SERVERID
fi

mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update users set wwwserver='$SERVERID' where wwwserver='' or wwwserver is NULL;"

mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update users set mailserver='$SERVERID' where mailserver='' or mailserver is NULL;"

mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update users set mysqlserver='$SERVERID' where mysqlserver='' or mysqlserver is NULL;"

test -d /usr/local/pd-admin2/UPDATE.INF && chgrp pdadmin /usr/local/pd-admin2/UPDATE.INF && chmod 750 /usr/local/pd-admin2/UPDATE.INF

if [ -d /usr/local/pd-admin2/awstats ]; then
   chmod 755 /usr/local/pd-admin2/awstats
fi

if [ ! -e /opt/pdadmin/tmp/.chgrp_logs ]; then
   cd /home && for i in *; do test -e $i/logs && chgrp -R $i /home/$i/logs && chmod 775 $i/logs; done
   touch /opt/pdadmin/tmp/.chgrp_logs
fi

chown root:www /opt/pdadmin/www/customer/navigation.cgi /opt/pdadmin/www/administrator/navigation.cgi /opt/pdadmin/www/customer/customer.cgi /opt/pdadmin/www/administrator/administrator.cgi /opt/pdadmin/www/pop3/pop3.cgi /opt/pdadmin/www/pop3/navigation.cgi /opt/pdadmin/www/pop3/autoconfigure.cgi

chown qmaild:popuser /opt/pdadmin/bin/email-address-by-pop3-login.pl
chmod 4750 /opt/pdadmin/bin/email-address-by-pop3-login.pl

chmod 4750 /opt/pdadmin/www/customer/navigation.cgi
chmod 4750 /opt/pdadmin/www/administrator/navigation.cgi
chmod 4750 /opt/pdadmin/www/customer/customer.cgi
chmod 4750 /opt/pdadmin/www/administrator/administrator.cgi
chmod 4750 /opt/pdadmin/www/pop3/pop3.cgi
chmod 4750 /opt/pdadmin/www/pop3/autoconfigure.cgi
chmod 4750 /opt/pdadmin/www/pop3/navigation.cgi
chmod 4755 /opt/pdadmin/bin/reseller-sshkeys

chown popuser:popuser /opt/pdadmin/bin/forward_filter
chmod 4755 /opt/pdadmin/bin/forward_filter
chown popuser:popuser /opt/pdadmin/bin/forward_filter.pl
chmod 750 /opt/pdadmin/bin/forward_filter.pl

chmod 755 /opt/pdadmin/bin/backup_write_dump.sh
chmod 755 /opt/pdadmin/bin/backup_user.sh

chown popuser:popuser /opt/pdadmin/bin/forward_filter
chmod 4755 /opt/pdadmin/bin/forward_filter

chown root:qmail /var/qmail/users/
chmod 750 /var/qmail/users/

grep -q greylist /etc/tcp.smtp 1>/dev/null || cp $HERE/templates/tcp.smtp /etc/
test -e /var/qmail/control/greylist || cp $HERE/templates/control /var/qmail/control/greylist
tcprules /etc/tcp.smtp.cdb /etc/tcp.smtp.tmp < /etc/tcp.smtp

svc -u /service/qmail-smtpd

type -p rrdtool >/dev/null 2>&1 && ( crontab -l | grep -q /opt/pdadmin/bin/stats_load.sh || echo "*/5  *   * * *  /opt/pdadmin/bin/stats_load.sh update" | bash $HERE/tools/crontab_add.sh )
( crontab -l | grep -q /opt/pdadmin/bin/top.sh         || echo "*    *   * * *  /opt/pdadmin/bin/top.sh" | bash $HERE/tools/crontab_add.sh )
( crontab -l | grep -q /opt/pdadmin/bin/msa_warning.pl || echo "*/2  *   * * *  /opt/pdadmin/bin/msa_warning.pl" | bash  $HERE/tools/crontab_add.sh )

perl $HERE/tools/crontab_licensekey.pl

cp /var/qmail/control/me /opt/pdadmin/etc/qmail_hostname

test -e /opt/pdadmin/tmp/redirect_updated || {
   echo "Importiere Redirects";
   $HERE/tools/update_redirect.pl
   touch /opt/pdadmin/tmp/redirect_updated
}

if [ -e /opt/pdadmin/etc/webdav.conf.dist ] && [ ! -e /opt/pdadmin/etc/webdav.conf ]; then
   mv /opt/pdadmin/etc/webdav.conf.dist /opt/pdadmin/etc/webdav.conf
fi

test -e /usr/local/pd-admin2/httpd-2.4/conf/httpd24.conf-template || cp $HERE/templates/httpd24.conf-template /usr/local/pd-admin2/httpd-2.4/conf/httpd24.conf-template

chown root:www /usr/local/pd-admin2/httpd-2.4/conf && \
chmod 750 /usr/local/pd-admin2/httpd-2.4/conf 

sed -i 's,#LoadModule proxy_module modules/mod_proxy.so,LoadModule proxy_module modules/mod_proxy.so,' \
   /usr/local/pd-admin2/httpd-2.4/conf/httpd24.conf-template

sed -i 's,#LoadModule proxy_http_module modules/mod_proxy_http.so,LoadModule proxy_http_module modules/mod_proxy_http.so,' \
   /usr/local/pd-admin2/httpd-2.4/conf/httpd24.conf-template

mkdir -p /opt/pdadmin/etc/ssl-validation/.well-known/acme-challenge
chown pdadmin /opt/pdadmin/etc/ssl-validation/.well-known/acme-challenge

for i in httpd_vhosts.pl-20170403 httpd_vhosts.pl--20170411 httpd_vhosts.pl~backup; do
test -e /opt/pdadmin/bin/$i && rm /opt/pdadmin/bin/$i
done

mkdir -p /opt/pdadmin/etc/ssl-validation/.well-known/pki-validation/
chown pdadmin:pdadmin /opt/pdadmin/etc/ssl-validation/.well-known/pki-validation/

test -e /lib/libexpat.so.1 || ln -s /opt/pdadmin/lib/libexpat.so.1 /lib

test -e BUILD_x86_64 && {
   for i in libssl libcrypto; do
      test -e /lib64/$i.so.10 || ln -sf /usr/local/pd-admin2/lib/$i.so /lib64/$i.so.10
      test -e /usr/lib/x86_64-linux-gnu/$i.so.1.1 && {
               test -e /usr/lib/x86_64-linux-gnu/$i.so.10 || \
           ln -s /usr/lib/x86_64-linux-gnu/$i.so.1.1 /usr/lib/x86_64-linux-gnu/$i.so.10
      }
   done
}

for i in thunderbird outlook; do 
  test -e /opt/pdadmin/etc/autoconfig/$i || mv /opt/pdadmin/etc/autoconfig/$i.dist /opt/pdadmin/etc/autoconfig/$i
  grep -q password-encrypted /opt/pdadmin/etc/autoconfig/$i && mv /opt/pdadmin/etc/autoconfig/$i.dist /opt/pdadmin/etc/autoconfig/$i
done
grep -q '<LoginName>$LoginName</LoginName>' /opt/pdadmin/etc/autoconfig/outlook || mv /opt/pdadmin/etc/autoconfig/outlook.dist /opt/pdadmin/etc/autoconfig/outlook


mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "grant CREATE TEMPORARY TABLES on vadmin.* to vadmin@localhost;"
#mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "update mysql.user set Create_tmp_table_priv='Y' where user='vadmin';"
#mysql -u root -p`cat /opt/pdadmin/etc/mysql_rootpw.conf` vadmin -e "flush privileges;"

/opt/pdadmin/bin/httpd_vhosts.pl

echo
echo "Update erfolgreich."
